import java.util.ArrayList;
import java.util.HashMap;

import javafx.animation.KeyFrame;
import javafx.animation.Timeline;
import javafx.application.Application;
import javafx.application.Platform;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;
import javafx.collections.ObservableList;
import javafx.event.Event;
import javafx.scene.AmbientLight;
import javafx.scene.Group;
import javafx.scene.LightBase;
import javafx.scene.Node;
import javafx.scene.PerspectiveCamera;
import javafx.scene.PointLight;
import javafx.scene.Scene;
import javafx.scene.SubScene;
import javafx.scene.control.Alert;
import javafx.scene.control.Alert.AlertType;
import javafx.scene.control.ButtonType;
import javafx.scene.input.KeyCode;
import javafx.scene.input.KeyEvent;
import javafx.scene.layout.StackPane;
import javafx.scene.paint.Color;
import javafx.scene.paint.CycleMethod;
import javafx.scene.paint.LinearGradient;
import javafx.scene.paint.Stop;
import javafx.scene.text.Font;
import javafx.scene.text.FontWeight;
import javafx.scene.text.Text;
import javafx.scene.transform.Translate;
import javafx.stage.Stage;
import javafx.util.Duration;

/**
 * AvP[VNX
 */
public class PRApplication extends Application implements PRConstant {

	/** tF[Y */
	private		int						phase					= PHASE_INIT;

	/**  */
	private		int						timeCtrl				= 0;
	private		int						time					= 0;

	/** vC[ */
	private		int						countPrusher			= 0;

	/** Xe[W */
	private		int						stage					= 0;

	/** XRA */
	private		int						score					= 0;

	/** nCXRA */
	private		int						scoreHigh				= 30000;

	/** [h */
	private		int						mode					= 0;

	/** yC */
	private		StackPane				pane					= null;

	/** V[ */
	private		Scene					scene					= null;

	/** 3DV[ */
	private		SubScene				scene3D					= null;

	/** 2DV[ */
	private		SubScene				scene2D					= null;

	/** J */
	private		PerspectiveCamera		camera					= null;

	/**  */
	private		LightBase				light					= null;

	/** pl3D */
	private		PRPanel3D				panel3D					= null;

	/** pl2D */
	private		Group					panel2D					= null;

	/** eLXg */
	private		Text					textKey					= null;
	private		Text					textControlStick		= null;
	private		Text					textReverse				= null;
	private		Text					textStage				= null;
	private		Text					textTime				= null;
	private		Text					textScore				= null;
	private		Text					textScoreHigh			= null;
	private		Text					textPrusher				= null;
	private		Text					textBy					= null;
	private		Text					textStage2				= null;
	private		Text					textGameOver			= null;

	/** L[ĂԈꗗ */
	private HashMap<KeyCode, String>	mapKeyPress				= null;

	// Q[tO
	private		boolean					flgPlaying				= true;

	// ^Cg
	private		PRSpriteTitlePrusher	spriteTitlePrusher		= null;

	// ^CgAXeC_[
	private		PRSpriteTitleShip		spriteTitleShip			= null;

	/** [hZNg */
	private		PRSpriteMode			spriteMode				= null;

	/** vC[ */
	private		PRSpritePrusher			spritePrusher			= null;

	/** bN */
	private		PRLock					lock					= null;

	/** n */
	private		PRSpriteGround			spriteGround			= null;

	/**  */
	private		PRSpriteSky				spriteSky				= null;

	/** ^C */
	private		PRSpriteTile			spriteTile				= null;

	/** XvCgO[v_ */
	private		PRSpriteGroupCloud		spriteGroupCloud		= null;

	/** ʉǗ */
	private		int						indexShot				= 0;
	private		int						indexBomb				= 0;
	private		int						indexHew				= 0;
	private		int						indexRapel				= 0;
	private		int						indexTamaTeki			= 0;
	private		int						indexLaser1Teki			= 0;
	private		int						indexLockon				= 0;

	/** BGM^ʉ */
	private		PRSoundMP3				mp3Title				= null;
	private		PRSoundMP3				mp3BGM					= null;
	private		PRSoundMP3				mp3BGMTengu				= null;
	private		PRSoundMP3				mp3BGMRedEye			= null;
	private		PRSoundMP3				mp3Talk1				= null;
	private		PRSoundMP3				mp3Talk2				= null;
	private		PRSoundMP3				mp3Ending				= null;
	private		PRSoundEffect[]			waveShots				= null;
	private		PRSoundEffect[]			waveBombs				= null;
	private		PRSoundEffect[]			waveHews				= null;
	private		PRSoundEffect[]			waveRapels				= null;
	private		PRSoundEffect[]			waveTamaTekis			= null;
	private		PRSoundEffect[]			waveLaser1Tekis			= null;
	private		PRSoundEffect[]			waveLockons				= null;
	private		PRSoundMP3				mp3Bump					= null;
	private		PRSoundMP3				mp3BGMFanfare			= null;
	private		PRSoundMP3				mp3GameOver				= null;

	/** tF[hAEgtO */
	private		boolean					flgFadeout				= false;
	private		boolean					flgFadeoutFanfare		= false;

	/** tF[hAEg{[ */
	private		double					volumeFadeout			= 0.02;

	/** {[iBGMj */
	private		double					volume					= 1.0;
	private		double					volumeFanfare			= 1.0;

	/** Xg[[ */
	private		PRStoryPrusher			storyPrusher			= null;

	/** XvCgO[vꗗ */
	private		ArrayList<PRSpriteGroup>	spriteGroupLst			= null;

	/**
	 * s
	 * <pre>
	 * \bhA͂܂܂B
	 * </pre>
	 * @param args 
	 */
	public static void main(String[] args){

		// AvP[VN܂
		launch(args);

	} // end main

	/**
	 * X^[g
	 * <pre>
	 * s܂B
	 * </pre>
	 */
	@Override
	public void start(Stage primaryStage){

		try{

			// PRImageɃAvP[Vݒ
			PRImage.setApplication(this);

			// ObjReaderɃAvP[Vݒ
			ObjReader.setApplication(this);

			// XvCg
			PRSpriteMode.init();
			PRSpriteSky.init();
			PRSpriteTitlePrusher.init();
			PRSpriteTitleShip.init();
			PRSpritePrusher.init();
			PRSpriteTama.init();
			PRSpriteRock.init();
			PRSpriteTengu.init();
			PRSpriteTree.init();
			PRSpritePole.init();
			PRSpriteBuilding.init();
			PRSpriteStone.init();
			PRSpriteShrub.init();
			PRSpriteCloud.init();
			PRSpriteShip.init();
			PRSpriteRedEye.init();
			PRSpriteTamaTeki.init();
			PRSpriteEnding.init();

			// yC𐶐
			pane = new StackPane();

			// V[𐶐
			// Zobt@LɂiŌ̈Abooleanj
			scene = new Scene(pane, PRConstant.WIDTH, PRConstant.HEIGHT, true);

			// wiɂ
			scene.setFill(Color.BLACK);

			// V[ݒ
			primaryStage.setScene(scene);

			// ^Cgݒ
			primaryStage.setTitle("Prusher3D");

			// EBhEۂɈSɏI
			primaryStage.setOnCloseRequest(req -> {
				// JavaFXAvP[VI
				Platform.exit();
				// ɏIĂȂXbhI
				System.exit(0);
			});

			// BGMEʉ𐶐
			mp3Title = new PRSoundMP3(this, "sound/PRMusic_Opening.mp3", true);
			mp3BGM = new PRSoundMP3(this, "sound/PRMusic_MainBGM.mp3", true);
			mp3BGMTengu = new PRSoundMP3(this, "sound/PRMusic_TENGU.mp3", true);
			mp3BGMRedEye = new PRSoundMP3(this, "sound/PRMusic_RedEyes.mp3", true);
			mp3Talk1 = new PRSoundMP3(this, "sound/PRVo_GetReady.mp3", false);
			mp3Talk2 = new PRSoundMP3(this, "sound/PRVo_YourDoingGreat.wav", false);
			mp3Ending = new PRSoundMP3(this, "sound/PRMusic_Ending.mp3", false);
			waveShots = new PRSoundEffect[10];
			for(int i = 0; i < 10; i++){
				waveShots[i] = new PRSoundEffect(this, "sound/PRSE_Shot.wav", false);
			}
			waveBombs = new PRSoundEffect[10];
			for(int i = 0; i < 10; i++){
				waveBombs[i] = new PRSoundEffect(this, "sound/PRSE_Bom1.wav", false);
			}
			waveHews = new PRSoundEffect[10];
			for(int i = 0; i < 10; i++){
				waveHews[i] = new PRSoundEffect(this, "sound/PRSE_Bom2.wav", false);
			}
			waveRapels = new PRSoundEffect[10];
			for(int i = 0; i < 10; i++){
				waveRapels[i] = new PRSoundEffect(this, "sound/PRSE_Reflection.wav", false);
			}
			waveTamaTekis = new PRSoundEffect[10];
			for(int i = 0; i < 10; i++){
				waveTamaTekis[i] = new PRSoundEffect(this, "sound/PRSE_Lase1.wav", false);
			}
			waveLaser1Tekis = new PRSoundEffect[10];
			for(int i = 0; i < 10; i++){
				waveLaser1Tekis[i] = new PRSoundEffect(this, "sound/PRSE_Lase2.wav", false);
			}
			waveLockons = new PRSoundEffect[10];
			for(int i = 0; i < 10; i++){
				waveLockons[i] = new PRSoundEffect(this, "sound/PRSE_LockOn.wav", false);
			}
			mp3Bump = new PRSoundMP3(this, "sound/PRVo_Ah.mp3", false);
			mp3BGMFanfare = new PRSoundMP3(this, "sound/PRMusic_Fanfare.mp3", false);
			mp3GameOver = new PRSoundMP3(this, "sound/PRMusic_GameOver.mp3", false);

			// Xg[[NX𐶐
			storyPrusher = new PRStoryPrusher(this);

			// XvCgO[vꗗ
			spriteGroupLst = new ArrayList<PRSpriteGroup>(100);

			// O[v𐶐
			panel3D = new PRPanel3D(this);

			// XvCgꗗ𐶐
			scene3D = new SubScene(panel3D, PRConstant.WIDTH, PRConstant.HEIGHT, true, null);

			// XvCgwꗗɒǉ
			pane.getChildren().add(scene3D);

			// Jݒ
			initCamera();

			// ݒ
			initLight();

			// ArGg
			AmbientLight ambientLight = new AmbientLight(Color.rgb(60, 60, 60));
			panel3D.getChildren().add(ambientLight);

			// nʂ쐬
			spriteGround = new PRSpriteGround(this);

			// nʂǉ
			panel3D.getChildren().add(spriteGround);

			// 쐬
			spriteSky = new PRSpriteSky(this);

			// ǉ
			panel3D.getChildren().add(spriteSky);

			// ^C쐬
			spriteTile = new PRSpriteTile(this);

			// ^Cǉ
			panel3D.getChildren().add(spriteTile);

			// O[v𐶐
			panel2D = new Group();

			// XvCgꗗ𐶐
			scene2D = new SubScene(panel2D, PRConstant.WIDTH, PRConstant.HEIGHT);

			// XvCgwꗗɒǉ
			pane.getChildren().add(scene2D);

			// eLXg𐶐
			textKey = new Text(272, 500, "PUSH SPACE KEY");
			textControlStick = new Text(320, 550, "CONTROL STICK MODE");
			textReverse = new Text(320, 580, "REVERSE MODE");
			textStage = new Text(640, 20, "STAGE:" + stage);
			textTime = new Text(640, 792, "TIME:" + storyPrusher.getStoryTime());
			textScore = new Text(64, 20, "SCORE:" + score);
			textScoreHigh = new Text(288, 20, "HIGH-SCORE:" + scoreHigh);
			textPrusher = new Text(32, 792, "PRUSHER: ");
			textBy = new Text(204, 720, "PROGRAMED  BY  KIN  /  MUSIC  BY  Aki2");
			textStage2 = new Text(304, 384, "STAGE");
			textGameOver = new Text(304, 400, "GAME OVER");

			// tHgݒ
			textKey.setFont(Font.font("Meiryo", FontWeight.BOLD, 32));
			textControlStick.setFont(Font.font("Meiryo", FontWeight.BOLD, 20));
			textReverse.setFont(Font.font("Meiryo", FontWeight.BOLD, 20));
			textStage.setFont(Font.font("Meiryo", FontWeight.BOLD, 20));
			textTime.setFont(Font.font("Meiryo", FontWeight.BOLD, 20));
			textScore.setFont(Font.font("Meiryo", FontWeight.BOLD, 20));
			textScoreHigh.setFont(Font.font("Meiryo", FontWeight.BOLD, 20));
			textPrusher.setFont(Font.font("Meiryo", FontWeight.BOLD, 20));
			textBy.setFont(Font.font("Meiryo", FontWeight.BOLD, 20));
			textStage2.setFont(Font.font("Meiryo", FontWeight.BOLD, 48));
			textGameOver.setFont(Font.font("Meiryo", FontWeight.BOLD, 32));

			Stop[] stops = new Stop[] { new Stop(0, Color.BLUE), new Stop(0.5, Color.WHITE), new Stop(1, Color.BLUE)};
			LinearGradient lgStage2 = new LinearGradient(1, 0, 0, 1, true, CycleMethod.NO_CYCLE, stops);

			// F̐ݒ
			textKey.setFill(Color.WHITE);
			textControlStick.setFill(Color.YELLOW);
			textReverse.setFill(Color.LIGHTGRAY);
			textStage.setFill(Color.LIGHTGRAY);
			textTime.setFill(Color.GRAY);
			textScore.setFill(Color.WHITE);
			textScoreHigh.setFill(Color.BLUE);
			textPrusher.setFill(Color.YELLOW);
			textBy.setFill(Color.WHITE);
			textStage2.setFill(lgStage2);
			textGameOver.setFill(Color.WHITE);

			textKey.setStroke(Color.BLACK);
			textControlStick.setStroke(Color.BLACK);
			textReverse.setStroke(Color.BLACK);
			textStage.setStroke(Color.BLACK);
			textTime.setStroke(Color.BLACK);
			textScore.setStroke(Color.BLACK);
			textScoreHigh.setStroke(Color.WHITE);
			textPrusher.setStroke(Color.RED);
			textBy.setStroke(Color.BLUE);
			textStage2.setStroke(Color.BLACK);
			textGameOver.setStroke(Color.BLACK);

			// eLXgǉ
			panel2D.getChildren().add(textStage);
			panel2D.getChildren().add(textTime);
			panel2D.getChildren().add(textScore);
			panel2D.getChildren().add(textScoreHigh);
			panel2D.getChildren().add(textPrusher);

			// ^Cg𐶐
			spriteTitlePrusher = new PRSpriteTitlePrusher(this);

			// ^CgAXeC_[𐶐
			spriteTitleShip = new PRSpriteTitleShip(this);

			// vC[𐶐
			spritePrusher = new PRSpritePrusher(this);

			// bN𐶐
			lock = new PRLock(this);

			// L[󋵈ꗗ𐶐
			mapKeyPress = new HashMap<KeyCode, String>();

			// L[Cxgo^
			scene.addEventHandler(KeyEvent.KEY_PRESSED, event -> sceneKeyPressed(event));

			// L[𗣂Cxgo^
			scene.addEventHandler(KeyEvent.KEY_RELEASED, event -> sceneKeyReleased(event));

			// EChETCYύXXi[ǉ
			pane.widthProperty().addListener((observable, oldValue, newValue) -> windowResized());
			pane.heightProperty().addListener((observable, oldValue, newValue) -> windowResized());

			// EBhE\
			primaryStage.show();

			// ԏ
			timeCtrl = 0;
			time = 0;

			// ^C}[X^[g
			Timeline timer = new Timeline(new KeyFrame(Duration.millis(4), event -> runCtrl()));
			timer.setCycleCount(Timeline.INDEFINITE);
			timer.play();

		}catch(Exception ex){
			// X^bNg[Xo
			ex.printStackTrace();
			// G[\
			Alert alert = new Alert(AlertType.ERROR , "" , ButtonType.OK);
			alert.setTitle("G[");
			alert.getDialogPane().setContentText(ex.toString());
			alert.showAndWait();
		}

	} // end start

	/**
	 * ^C}[s
	 * <pre>
	 * ^C}[IɌĂ΂܂B
	 * </pre>
	 */
	synchronized public void runCtrl() {

		// ԁ{P
		timeCtrl++;

		// ̎
		if(timeCtrl % 4 == 0){

			// s\bhĂяo
			this.run();

		// em[h̐̎
		}else if(timeCtrl % 4 == 1){

			// 3Dpls
			panel3D.run();

		// O[v̐^|̎
		}else if(timeCtrl % 4 == 3){

			// O[vs\bhĂяo
			this.runGroup();

			// |̎ԁFXvCgO[v
			if(timeCtrl % 40 == 3){

				// O[vN[\bhĂяo
				this.cleanGroup();

			// N[
			}else if(timeCtrl % 40 == 11){

				// 3Dpl̃N[\bhs
				panel3D.clean();

			} // end if

			// tF[Y|Q[̏ꍇA
			if(phase == PHASE_GAME){

				// bNI
				if(timeCtrl % 40 == 19){

					// bNI
					Platform.runLater( () -> lock.lockon());

				// bNIO
				}else if(timeCtrl % 40 == 27){

					// bNIO
					Platform.runLater( () -> lock.unlock());

				} // end if 

			} // end if tF[Y|Q[̏ꍇ

		} // end if 

	} // end runCtrl

	/**
	 * s
	 * <pre>
	 * ^C}[IɌĂ΂܂B
	 * </pre>
	 */
	synchronized public void run() {

		// ԁ{P
		time++;

		// tF[Y|̏ꍇA
		if(phase == PHASE_INIT){

			// Xe[W
			stage = 0;

			// XRA
			score = 0;

			// ԏ
			time = 0;

			// vC[
			countPrusher = 5;

			// XvCgO[v̗vfNA
			spriteGroupLst.clear();

			// Xg[[Zbg
			storyPrusher.reset();

			// Jʒu߂
			camera.setTranslateX(0.0);
			camera.setTranslateY(0.0);

			// ^Cg
			spriteTitlePrusher.initPosition();

			// ^Cgǉ
			this.addNode(spriteTitleShip);

			// tF[Y|^CgP
			phase = PHASE_TITLE_1;

		// tF[Y|^CgP̏ꍇA
		}else if(phase == PHASE_TITLE_1){

			// Rb
			if(time == 180){

				// ^Cgǉ
				this.addNode(spriteTitlePrusher);

			}

			// Xy[XꂽꍇA
			if(this.isKeyPressed(KeyCode.SPACE)){

				// Rb̏ꍇA
				if(time < 180){

					// ^Cgǉ
					this.addNode(spriteTitlePrusher);

				}

				// ^CgXLbv
				spriteTitlePrusher.skipTitle();

				// tF[Y|^CgQ
				phase = PHASE_TITLE_2;

			}

		// tF[Y|^CgQ̏ꍇA
		}else if(phase == PHASE_TITLE_2){

			// ^Cg҂

		// tF[Y|^CgȐꍇA
		}else if(phase == PHASE_TITLE_3){

			// ԂA
			if(time == 1){

				// eLXgǉ
				panel2D.getChildren().add(textKey);
				panel2D.getChildren().add(textControlStick);
				panel2D.getChildren().add(textReverse);
				panel2D.getChildren().add(textBy);

				// [hZNg𐶐
				spriteMode = new PRSpriteMode(this);

				// [hZNgǉ
				this.addNode(spriteMode);

				// BGMX^[g
				mp3Title.start();

			} // end if Ԃ

			// オꂽꍇA
			if(this.isKeyPressed(KeyCode.UP)){

				// [hύX
				mode = 0;

				// [hύX
				spriteMode.setMode(mode);

			// ꂽꍇA
			}else if(this.isKeyPressed(KeyCode.DOWN)){

				// [hύX
				mode = 1;

				// [hύX
				spriteMode.setMode(mode);

			// Xy[XꂽꍇA
			}else if(this.isKeyPressed(KeyCode.SPACE)){

				// ^Cg폜
				this.removeNode(spriteTitlePrusher);

				// ^CgAXeC_[폜
				this.removeNode(spriteTitleShip);

				// eLXg폜
				panel2D.getChildren().remove(textKey);
				panel2D.getChildren().remove(textControlStick);
				panel2D.getChildren().remove(textReverse);
				panel2D.getChildren().remove(textBy);

				// [hZNg폜
				this.removeNode(spriteMode);

				// BGMXgbv
				mp3Title.stop();

				// [hݒ
				spritePrusher.setMode(mode);

				// vC[̈ʒu߂
				spritePrusher.initPos();

				// vC[X^[g
				spritePrusher.start();

				// vC[ǉ
				this.addNode(spritePrusher);

				// ʉX^[g
				mp3Talk1.start();

				// BGMX^[g
				mp3BGM.start();

				// ԏ
				time = 0;

				// tF[Y|Xe[WX^[g
				phase = PHASE_STAGE_START;

			}

		// tF[Y|Xe[WX^[g̏ꍇA
		}else if(phase == PHASE_STAGE_START){

			// ԂA
			if(time == 1){

				// Xe[W{P
				stage++;

				// Xe[W
				textStage.setText("STAGE:" + stage);

				// ^C
				textTime.setText("TIME:" + storyPrusher.getStoryTime());

				// eLXg|Xe[WҏW
				textStage2.setText("STAGE " + stage);

				// XRA
				textScore.setText("SCORE:" + score);

				// eLXgǉ
				panel2D.getChildren().add(textStage2);

				// Xe[Wݒ
				spriteSky.setStage(stage);
				spriteGround.setStage(stage);
				spriteTile.setStage(stage);

				// Xe[WP̏ꍇA
				if(stage == 1){

					// vC[̉eǉ
					this.addShadow(spritePrusher, 0.1);

				// Xe[WȐꍇA
				}else if(stage == 3){

					// vC[̉e폜
					this.removeShadow(spritePrusher);

				}

			// SbA
			}else if(time == 240){

				// eLXg폜
				panel2D.getChildren().remove(textStage2);

				// ԏ
				time = 0;

				// tF[Y|Q[
				phase = PHASE_GAME;

			} // end if Ԃ

		// tF[Y|Q[̏ꍇA
		}else if(phase == PHASE_GAME){

			// XRA{P
			addScore(1);

			// XRA
			textScore.setText("SCORE:" + score);

			// nCXRAA
			if(score > scoreHigh){

				// nCXRAύX
				scoreHigh = score;

				// nCXRA
				textScoreHigh.setText("HIGH-SCORE:" + scoreHigh);

			}

			// ^C
			textTime.setText("TIME:" + storyPrusher.getStoryTime());

			// Xg[[i߂
			storyPrusher.next();

		// tF[Y|Xe[WNȀꍇA
		}else if(phase == PHASE_STAGE_CLEAR){

			// ʉX^[g
			mp3Talk2.start();

			// ԏ
			time = 0;

			// tF[Y|Xe[WX^[g
			phase = PHASE_STAGE_START;

		// tF[Y|Փ˂̏ꍇA
		}else if(phase == PHASE_BUMP){

			// ԂA
			if(time > 210){

				// vC[|P
				countPrusher--;

				// vC[ύX
				StringBuilder sb = new StringBuilder();

				// vC[
				for(int i = 0; i < countPrusher; i++){
					sb.append("");
				}

				// vC[ύX
				textPrusher.setText("PRUSHER: " + sb.toString());

				// vC[OɂȂꍇA
				if(countPrusher == 0){

					// BGMXgbv
					mp3BGM.stop();
					mp3BGMTengu.stop();
					mp3BGMRedEye.stop();

					// ԏ
					time = 0;

					// tF[Y|Q[I[p[
					phase = PHASE_GAMEOVER;

				// vC[cĂꍇA
				}else{

					// vC[̃tF[YX^[g
					spritePrusher.start();

					// ʉX^[g
					mp3Talk1.start();

					// ԏ
					time = 0;

					// tF[Y|Q[
					phase = PHASE_GAME;

				} // end if

			} // end if // Ԃ

		// tF[Y|Q[I[o[̏ꍇA
		}else if(phase == PHASE_GAMEOVER){

			// ԂA
			if(time == 120){

				// vC[폜
				removeNode(spritePrusher);

				// eLXgǉ
				panel2D.getChildren().add(textGameOver);

				// ʉX^[g
				mp3GameOver.start();

			// ԂA
			}else if(time > 1080){

				// _IiݗL͏̒Ŕf̂ŁAŌĂяoĖȂj
				this.finishCloud();

				// eLXg폜
				panel2D.getChildren().remove(textGameOver);

				// GXvCgNA
				this.removeSpriteTs();

				// XvCgO[v̗vfNA
				spriteGroupLst.clear();

				// ԏ
				time = 0;

				// tF[Y|
				phase = PHASE_INIT;

			}

		// tF[Y|Q[NȀꍇA
		}else if(phase == PHASE_GAME_CLEAR){

			// ԂA
			if(time == 1){

				// BGMXgbv
				mp3BGM.stop();
				mp3BGMRedEye.stop();

				// vC[ɃQ[NA`
				spritePrusher.clearGame();

			// 5b
			}else if(time < 300){

				// Ȃ

			// 5b
			}else if(time == 300){

				// vC[폜
				removeNode(spritePrusher);

				// Jʒu߂
				camera.setTranslateX(0.0);
				camera.setTranslateY(0.0);

				// GfBO𐶐
				PRSpriteEnding spriteEnding = new PRSpriteEnding(this);

				// m[hǉ
				this.addNode(spriteEnding);

			// LȊO
			}else{

				// Ȃ
				// I̓GfBONXs

			} // end if 

		} // end if tF[Y

		// tF[Y| Xe[WX^[g ܂ Q[ ܂ Q[I[o[ ̏ꍇA
		if(phase == PHASE_STAGE_START || phase == PHASE_GAME || phase == PHASE_GAMEOVER){

			// is
			progress();

		}

		// tF[hAEg̏ꍇA
		if(flgFadeout){

			// tF[hAEg
			volume = volume - volumeFadeout;
			mp3BGM.setVolume(volume);

			// {[OɂȂꍇA
			if(volume <= 0.0){
				// tF[hAEg
				flgFadeout = false;
				// Xgbv
				mp3BGM.stop();
				// {[߂
				volume = 1.0;
				Platform.runLater( () -> mp3BGM.setVolume(1.0));
			}

		} // end if tF[hAEg̏ꍇ

		// t@t@[ tF[hAEg̏ꍇA
		if(flgFadeoutFanfare){

			// tF[hAEg
			volumeFanfare = volumeFanfare - 1.0 / 360;
			mp3BGMFanfare.setVolume(volumeFanfare);

			// {[OɂȂꍇA
			if(volumeFanfare <= 0.0){
				// tF[hAEg
				flgFadeoutFanfare = false;
				// Xgbv
				mp3BGMFanfare.stop();
				// {[߂
				volumeFanfare = 1.0;
				Platform.runLater( () -> mp3BGMFanfare.setVolume(1.0));
			}

		} // end if tF[hAEg̏ꍇ

	} // end run

	/**
	 * O[vs
	 * <pre>
	 * ^C}[IɌĂ΂܂B
	 * </pre>
	 */
	synchronized public void runGroup() {

		// tF[Y|Q[̏ꍇA
		if(phase == PHASE_GAME){

			// XvCgO[vꗗ̌擾
			int countSpriteGroupLst = spriteGroupLst.size();

			// XvCgO[vꗗ̌A[v
			for(int i = 0; i < countSpriteGroupLst; i++){

				// XvCgO[v擾
				PRSpriteGroup spriteGroup = spriteGroupLst.get(i);

				// XvCgO[vnullȊȌꍇA
				if(spriteGroup != null){

					// XvCgO[v̎Ԃi߂
					spriteGroup.forward();

					// XvCgO[vs
					spriteGroup.run();

				}

			} // end for XvCgO[vꗗ̌A[v

		} // end if tF[Y|Q[̏ꍇ

	} // end runGroup

	/**
	 * O[vN[
	 * <pre>
	 * ^C}[IɌĂ΂܂B
	 * </pre>
	 */
	synchronized public void cleanGroup() {

		// tF[Y|Q[̏ꍇA
		if(phase == PHASE_GAME){

			// XvCgO[vꗗ̌擾
			int countSpriteGroupLst = spriteGroupLst.size();

			// XvCgO[vꗗ̌100𒴂ꍇA
			if(countSpriteGroupLst > 100){

				// XvCgO[vꗗ̌A[v
				for(int i = 0; i < countSpriteGroupLst; i++){

					// XvCgO[v擾
					PRSpriteGroup spriteGroup = spriteGroupLst.get(i);

					// XvCgO[vnull̏ꍇA
					if(spriteGroup == null){

						// XvCgO[v߂
						spriteGroupLst.remove(i);

						// CfbNX߂
						i--;
						countSpriteGroupLst--;

					}

				} // end for XvCgO[vꗗ̌A[v

			} // end if XvCgO[vꗗ̌100𒴂ꍇ

		} // end if tF[Y|Q[̏ꍇ

	} // end cleanGroup

	/**
	 * is
	 * <pre>
	 * </pre>
	 */
	private void progress() {

		// Xe[WPƂQ̏ꍇA
		if(stage == 1 || stage == 2){

			// ؂oꍇA
			if(Math.random() < 0.12){

				// ؂𐶐
				PRSpriteShrub spriteShrub = new PRSpriteShrub(this, stage);

				// m[hǉ
				this.addNode(spriteShrub);

			} // end if

		} // end if Xe[W

	} // end progress

	/**
	 * tF[Yݒ
	 */
	public void setPhase(int phase){

		// ԏ
		time = 0;

		// tF[YύX
		this.phase = phase;

	} // end setPhase

	/**
	 * XRAZ
	 */
	public void addScore(int score){

		this.score = this.score + score;

	} // end addScore

	/**
	 * Q[擾
	 * @return boolean true|Q[^Q[ł͂Ȃ
	 */
	public boolean isPlaying(){
		return flgPlaying;
	}

	/**
	 * ՓˏԎ擾
	 */
	public boolean isBump(){
		return (phase == PHASE_BUMP);
	}

	/**
	 * m[hǉ
	 * <pre>
	 * m[hǉ܂B
	 * </pre>
	 * @param sprite m[h
	 */
	public void addNode(Node node){

		// 3DplNXĂяo
		panel3D.addNode(node);

	}

	/**
	 * m[h폜
	 * <pre>
	 * m[h폜܂B
	 * \bhł́A_~[m[hɒuArun\bh̒ō폜܂B
	 * nullɒułȂ
	 *  ListNXremove\bh𑽗p邱ƂŔzRs[𑽗p邱Ƃ邽
	 * idȂ邱Ƃł邾j
	 * </pre>
	 * @param sprite m[h
	 */
	public void removeNode(Node node){

		// 3DplNXĂяo
		panel3D.removeNode(node);

		// bNΏۂł΁AO
		lock.removeNode(node);

	}

	/**
	 * em[hǉ
	 * <pre>
	 * m[hǉ܂B
	 * </pre>
	 * @param sprite m[h
	 */
	public void addShadow(Node node){

		// 3DplNXĂяo
		panel3D.addShadow(node);

	}

	/**
	 * em[hǉ
	 * <pre>
	 * em[hǉ܂B
	 * </pre>
	 * @param sprite m[h
	 * @param radius a
	 */
	public void addShadow(Node node, double radius){

		// 3DplNXĂяo
		panel3D.addShadow(node, radius);

	}

	/**
	 * em[h폜
	 * <pre>
	 * em[h폜܂B
	 * </pre>
	 * @param sprite m[h
	 */
	public void removeShadow(Node node){

		// 3DplNXĂяo
		panel3D.removeShadow(node);

	}

	/**
	 * fBAr[ǉ
	 * @param sprite XvCg
	 */
	public void addMediaView(PRSoundMP3 mp3){

		// XvCgꗗ擾
		ObservableList<Node> nodeLst = pane.getChildren();

		// fBAr[ǉ
		nodeLst.add(mp3);

	} // end addMediaView

	/**
	 * fBAr[폜
	 * @param sprite XvCg
	 */
	public void removeMediaView(PRSoundMP3 mp3){

		// XvCgꗗ擾
		ObservableList<Node> nodeLst = pane.getChildren();

		// CfbNX߂
		int index = nodeLst.indexOf(mp3);

		// CfbNX擾łꍇA
		if(index != -1){

			// 폜
			nodeLst.remove(mp3);

		}

	} // end removeMediaView

	/**
	 * XvCgꗗ擾
	 * @return ObservableList<Node> XvCgꗗ
	 */
	public ObservableList<Node> getNodeLst(){

		// XvCgꗗ擾
		ObservableList<Node> nodeLst = panel3D.getChildren();

		// ^[
		return nodeLst;

	} // end getNodeLst

	/**
	 * XvCgO[vǉ
	 * @param spriteGroup XvCg
	 */
	public void addSpriteGroup(PRSpriteGroup spriteGroup){

		// XvCgO[vǉ
		spriteGroupLst.add(spriteGroup);

	} // end addSpriteGroup

	/**
	 * XvCgO[v폜
	 * @param spriteGroup XvCg
	 */
	public void removeSpriteGroup(PRSpriteGroup spriteGroup){

		// CfbNX߂
		int index = spriteGroupLst.indexOf(spriteGroup);

		// CfbNX擾łꍇA
		if(index != -1){

			// XvCgO[v폜
			spriteGroupLst.set(index, null);

		}

	} // end addSpriteGroup

	/**
	 * vC[擾
	 */
	public PRSpritePrusher getPRSpritePrusher(){
		return spritePrusher;
	}

	/**
	 * Xg[[擾
	 */
	public PRStoryPrusher getPRStoryPrusher(){
		return storyPrusher;
	}

	/**
	 * bN擾
	 */
	public PRLock getPRLock(){
		return lock;
	}

	/**
	 * Xe[W擾
	 */
	public int getStage(){
		return stage;
	}

	/**
	 * _Jn
	 */
	public void startCloud(){

		// XvCgO[v_𐶐
		spriteGroupCloud = new PRSpriteGroupCloud(this);

		// AvP[VɃXvCgO[vǉ
		this.addSpriteGroup(spriteGroupCloud);

	} // end startCloud

	/**
	 * _I
	 */
	public void finishCloud(){

		// XvCgO[v_݂ꍇA
		if(spriteGroupCloud != null){

			// XvCgO[v_I
			spriteGroupCloud.finish();

			// XvCgO[v_iIuWFNgJj
			spriteGroupCloud = null;

		} // XvCgO[v_݂ꍇ

	} // end finishCloud

	/**
	 * BGMX^[g
	 */
	public void startMP3BGM(double millis){

		// {[ftHglɖ߂
		mp3BGM.setVolume(1.0);

		// BGMtF[hAEgł͂ȂԂɖ߂
		flgFadeout = false;

		// BGMX^[g
		mp3BGM.start(millis);

	} // end startMP3BGM

	/**
	 * BGMtF[hAEg
	 * <pre>
	 * Ԃ̎w肪Ȃꍇ́A50t[0.83bŃtF[hAEg܂B
	 * <pre>
	 */
	public void fadeoutMP3BGM(){

		// tF[hAEg{[
		volumeFadeout = 0.02;

		// BGMtF[hAEg
		flgFadeout = true;

	} // end fadeoutMP3BGM

	/**
	 * BGMtF[hAEg
	 * <pre>
	 * t[Őݒ肵ĂB
	 * 60t[Őݒ肷1.00bŃtF[hAEg܂B
	 * <pre>
	 * @param frame tF[hAEgt[BPb60t[
	 */
	public void fadeoutMP3BGM(int frame){

		// tF[hAEg{[
		volumeFadeout = 1.0 / frame;

		// BGMtF[hAEg
		flgFadeout = true;

	} // end fadeoutMP3BGM

	/**
	 * VBGMX^[g
	 */
	public void startMP3BGMTengu(){

		// BGMX^[g
		mp3BGMTengu.start(0);

	} // end startMP3BGMTengu

	/**
	 * VBGMXgbv
	 */
	public void stopMP3BGMTengu(){

		// BGMXgbv
		mp3BGMTengu.stop();

	} // end stopMP3BGMTengu

	/**
	 * bhEACBGMX^[g
	 */
	public void startMP3BGMRedEye(){

		// BGMX^[g
		mp3BGMRedEye.start(0);

	} // end startMP3BGMRedEye

	/**
	 * bhEACBGMXgbv
	 */
	public void stopMP3BGMRedEye(){

		// BGMXgbv
		mp3BGMRedEye.stop();

	} // end stopMP3BGMRedEye

	/**
	 * t@t@[BGMX^[g
	 */
	public void startMP3BGMFanfare(){

		// t@t@[X^[g
		mp3BGMFanfare.start(0);

	} // end startMP3BGMFanfare

	/**
	 * t@t@[BGMtF[hAEg
	 */
	public void fadeoutMP3BGMFanfare(){

		// t@t@[BGMtF[hAEg
		flgFadeoutFanfare = true;

	} // end fadeoutMP3FanfareBGM

	/**
	 * GfBOBGMX^[g
	 */
	public void startMP3BGMEnding(){

		// GfBOX^[g
		mp3Ending.start();

	} // end startMP3BGMEnding

	/**
	 * VbgX^[g
	 */
	public void startWaveShot(){

		// ʉi߂
		indexShot = (indexShot == 9)?0: ++indexShot;
		// ʉX^[g
		waveShots[indexShot].start();

	} // end startWaveShot

	/**
	 * X^[g
	 */
	public void startWaveBomb(){

		// ʉi߂
		indexBomb = (indexBomb == 9)?0: ++indexBomb;
		// ʉX^[g
		waveBombs[indexBomb].start();

	} // end startWaveBomb

	/**
	 * ؂|X^[g
	 */
	public void startWaveHew(){

		// ʉi߂
		indexHew = (indexHew == 9)?0: ++indexHew;
		// ʉX^[g
		waveHews[indexHew].start();

	} // end startWaveHew

	/**
	 * ˕Ԃ艹X^[g
	 */
	public void startWaveRapel(){

		// ʉi߂
		indexRapel = (indexRapel == 9)?0: ++indexRapel;
		// ʉX^[g
		waveRapels[indexRapel].start();

	} // end startWaveRapel

	/**
	 * G̒eX^[g
	 */
	public void startWaveTamaTeki(){

		// ʉi߂
		indexTamaTeki = (indexTamaTeki == 9)?0: ++indexTamaTeki;
		// ʉX^[g
		waveTamaTekis[indexTamaTeki].start();

	} // end startWaveTamaTeki

	/**
	 * G̃[U[PX^[g
	 */
	public void startWaveLaser1Teki(){

		// ʉi߂
		indexLaser1Teki = (indexLaser1Teki == 9)?0: ++indexLaser1Teki;
		// ʉX^[g
		waveLaser1Tekis[indexLaser1Teki].start();

	} // end startWaveLaser1Teki

	/**
	 * bNX^[g
	 */
	public void startWaveLockon(){

		// ʉi߂
		indexLockon = (indexLockon == 9)?0: ++indexLockon;
		// ʉX^[g
		waveLockons[indexLockon].start();

	} // end startWaveLockon

	/**
	 * Փ
	 */
	public void bump(){

		// ʉX^[g
		mp3Bump.start();

		// ԏ
		time = 0;

		// tF[Y|Փ˂
		phase = PHASE_BUMP;

	} // end bump

	/**
	 * Jݒ
	 */
	private void initCamera(){

		// Jݒ
		camera  = new PerspectiveCamera(true);

		// J̋Ԃݒ
		camera.setFarClip(300);

		// Wݒ
		camera.getTransforms().add(new Translate(0.0 , -1.0 , 0.0));

		// Jݒ
		scene3D.setCamera(camera);

	} // end initCamera

	/**
	 * wiړX
	 * @param mx Xړ
	 */
	public void moveSkyX(double mx){
		spriteSky.moveX(mx);
	}

	/**
	 * JړY
	 * @param my Yړ
	 */
	public void moveCameraY(double my){
		camera.setTranslateY(camera.getTranslateY() + my);
	}

	/**
	 * ݒ
	 */
	public void initLight(){

		// ݒ
		if(light == null){

			light = new PointLight();

			// ݒ
			panel3D.getChildren().add(light);

		}

		// ʒu
		light.setTranslateX(-100);
		light.setTranslateY(-200);
		light.setTranslateZ(-100);

	} // end initLight

	/**
	 * ݒ
	 */
	public void initLight0(){

		// ʒu
		light.setTranslateX(10);
		light.setTranslateY(-10);
		light.setTranslateZ(-100);

	} // end initLight

	/**
	 * XvCgO[v
	 * <pre>
	 * XvCgO[v܂B
	 * Xo^Ăꍇɂ́ANA܂B
	 * </pre>
	 */
	public void initSpriteGroup(){

		// XvCgO[vꗗ
		this.spriteGroupLst = new ArrayList<PRSpriteGroup>(100);

	}

	/**
	 * GXvCgNA
	 */
	public void removeSpriteTs(){

		// XvCgꗗ擾
		ObservableList<Node> nodeLst = this.getNodeLst();

		// XvCgꗗ̌擾
		int countNodeLst = nodeLst.size();

		// XvCgꗗ̌A[v
		for(int i = 0; i < countNodeLst; i++){

			// XvCg擾
			Node node = nodeLst.get(i);

			// GXvCg̏ꍇA
			if(node instanceof PRSpriteT){
				// GXvCg폜
				this.removeNode(node);
			}

		} // end for XvCgꗗ̌A[v

	} // end removeSpriteTs

	/**
	 * L[ǂ`FbN
	 * @param code L[R[h
	 * @return boolean trueFĂ ^ falseFĂȂ
	 */
	public boolean isKeyPressed(KeyCode code){

		return mapKeyPress.containsKey(code);

	} // end isKeyPressed

	/**
	 * L[Cxg
	 * <pre>
	 * _LqsāAC^[tF[X쐬ȗĂ܂B
	 * </pre>
	 */
	public void sceneKeyPressed(Event e){

		KeyEvent ke = (KeyEvent)e;
		KeyCode code = ke.getCode();
		mapKeyPress.put(code, "");

	} // end sceneKeyPressed

	/**
	 * L[𗣂Cxg
	 * <pre>
	 * _LqsāAC^[tF[X쐬ȗĂ܂B
	 * </pre>
	 */
	public void sceneKeyReleased(Event e){

		KeyEvent ke = (KeyEvent)e;
		KeyCode code = ke.getCode();
		mapKeyPress.remove(code);

	} // end sceneKeyReleased

	/**
	 * EChETCYύXCxg
	 */
	public void windowResized(){

		// yCiEChEj̃TCY擾
		double widthPane = PRApplication.this.pane.getWidth();
		double heightPane = PRApplication.this.pane.getHeight();

		// 䗦߂
		double ratioWidth = (float)widthPane / PRConstant.WIDTH;
		double ratioHeight = (float)heightPane / PRConstant.HEIGHT;

		// 䗦̏߂
		double ratio = (ratioWidth < ratioHeight)?ratioWidth: ratioHeight;

		// eV[gk
		scene3D.setScaleX(ratio);
		scene3D.setScaleY(ratio);
		scene2D.setScaleX(ratio);
		scene2D.setScaleY(ratio);

		// yC̃V[Ĕzu
		scene3D.setLayoutX((widthPane - PRConstant.WIDTH) / 2);
		scene3D.setLayoutY((heightPane - PRConstant.HEIGHT) / 2);
		scene2D.setLayoutX((widthPane - PRConstant.WIDTH) / 2);
		scene2D.setLayoutY((heightPane - PRConstant.HEIGHT) / 2);

	} // end windowResized

}
