import java.util.HashMap;

import javafx.collections.ObservableList;
import javafx.geometry.BoundingBox;
import javafx.geometry.Bounds;
import javafx.geometry.Point3D;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.input.KeyCode;
import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.MeshView;
import javafx.scene.transform.Rotate;
import javafx.scene.transform.Translate;

/**
 * vC[
 */
public class PRSpritePrusher extends PRSprite {

	/** tF[Y|X^[g */
	private final int				PHASE_START			= 0;

	/** tF[Y|G */
	private final int				PHASE_MUTEKI		= 1;

	/** tF[Y|Q[ */
	private final int				PHASE_GAME			= 2;

	/** tF[Y|Փ */
	private final int				PHASE_BUMP			= 3;

	/** tF[Y|Q[NA */
	private final int				PHASE_GAME_CLEAR	= 4;

	/** YWn */
	private		double				yJimen				= 0.0;

	/** tF[Y */
	private		int					phase				= PHASE_START;

	/**  */
	private		int					time				= 0;

	/** ړ */
	private		KeyCode				moveUp				= KeyCode.DOWN;

	/** ړ */
	private		KeyCode				moveDown			= KeyCode.UP;

	/** eˎ */
	private		int					timeTama			= 0;

	/** G */
	private		boolean				flgMuteki			= false;

	/** Փˏ */
	private		boolean				flgBump				= false;

	/** Er */
	private		Group				groupArmRight		= null;

	/** t@CA[ */
	private		Group				groupFire			= null;

	/** r */
	private		Group				groupArmLeft		= null;

	/** E */
	private		Group				groupLegRight		= null;

	/**  */
	private		Group				groupLegLeft		= null;

	/** Er̐ */
	private		boolean				flgJimen			= true;
	private		int					angleLeg			= 0;
	private		int					dirLeg				= 1;

	/** ʒu */
	private		double				x					= 0.0;
	private		double				y					= 0.0;

	/** ł銴o */
	private		double				xx					= 0.0;
	private		double				yy					= 0.0;

	/** ړ */
	public		double				mx					= 0.0;
	public		double				my					= 0.0;

	/** C̃}eA */
	private		PhongMaterial		materail			= null;

	/** ]X */
	private		Point3D				px					= new Point3D(1.0, 0.0, 0.0);

	/** ]Y */
	private		Point3D				py					= new Point3D(0.0, 1.0, 0.0);

	/**
	 * 
	 */
	public static void init() {

		try{
			ObjReader.init(PRSpritePrusher.class, "3d/Prusher.obj");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 */
	public PRSpritePrusher(PRApplication application){

		// X[p[NXĂяo
		super(application);

		try{

			// IuWFNg
			HashMap<String, Group> map = ObjReader.create(this);

			// ep[cێ
			groupArmRight = map.get("Arm_Right");
			groupFire = map.get("Fire");
			groupArmLeft = map.get("Arm_Left");
			groupLegRight = map.get("Leg_Right_Leg");
			groupLegLeft = map.get("Leg_Left_Leg");

			// OXpɂ
			this.getTransforms().add(new Rotate(-10, Rotate.X_AXIS));

			// nʂɐڐG悤YWC
			Bounds bounds = this.getBoundsInParent();
			yJimen = -bounds.getHeight() / 2;
			y = yJimen;

			// ړ
			groupArmRight.setTranslateX(groupArmRight.getTranslateX() - 0.042);
			groupFire.setTranslateX(groupFire.getTranslateX() - 0.042);
			groupArmLeft.setTranslateX(groupArmLeft.getTranslateX() + 0.042);
			groupLegRight.setTranslateX(groupLegRight.getTranslateX() - 0.21);
			groupLegLeft.setTranslateX(groupLegLeft.getTranslateX() + 0.21);

			groupArmRight.setTranslateY(groupArmRight.getTranslateY() - 0.16);
			groupFire.setTranslateY(groupFire.getTranslateY() - 0.16);
			groupArmLeft.setTranslateY(groupArmLeft.getTranslateY() - 0.16);

			// S_ݒ
			groupArmRight.getTransforms().add(new Translate(0.0, 0.15, 0.0));
			groupFire.getTransforms().add(new Translate(0.0, 0.15, 0.0));
			groupArmLeft.getTransforms().add(new Translate(0.0, 0.15, 0.0));

			// ]ݒ
			groupArmRight.setRotationAxis(px);
			groupFire.setRotationAxis(px);
			groupArmLeft.setRotationAxis(px);
			groupLegRight.setRotationAxis(px);
			groupLegLeft.setRotationAxis(px);

			// ʒuݒ
			this.setTranslateX(0.0);
			this.setTranslateY(y);
			this.setTranslateZ(6.0);

			// C̃bVr[擾
			MeshView meshView = (MeshView)(groupFire.getChildren().get(0));

			// C̃}eA擾
			materail = (PhongMaterial)meshView.getMaterial();

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpritePrusher

	/**
	 * s
	 */
	@Override
	public void run(){

		// ԁ{P
		time++;

		// tF[Y|X^[g
		if(phase == PHASE_START){

			// ]
			super.setRotate(0);

			// ]ݒ
			super.setRotationAxis(py);

			// nʂɂꍇA
			if(y == yJimen){
				// nʂɂ
				flgJimen = true;
			}

			// G
			flgMuteki = true;

			// Փˏ
			flgBump = false;

			// tF[Y|G
			phase = PHASE_MUTEKI;

		// tF[Y|G
		}else if(phase == PHASE_MUTEKI){

			// RDOb
			if(time >= 180){

				// Ԃ
				time = 0;

				// tF[Y|Q[
				phase = PHASE_GAME;

			}

		// tF[Y|Q[
		}else if(phase == PHASE_GAME){

			// ړʏ
			mx = 0.0;
			my = 0.0;

			// ړ̏ꍇA
			if(application.isKeyPressed(moveUp)){

				// WvZ
				my = my - 0.06;

			} // end if ړ̏ꍇ

			// ړ̏ꍇA
			if(application.isKeyPressed(moveDown)){

				// WvZ
				my = my + 0.06;

			} // end if ړ̏ꍇ

			// ꂽꍇA
			if(application.isKeyPressed(KeyCode.LEFT)){

				// ړʌvZ
				mx = mx - 0.06;

			} // end if ꂽꍇ

			// EꂽꍇA
			if(application.isKeyPressed(KeyCode.RIGHT)){

				// ړʌvZ
				mx = mx + 0.06;

			} // end if Eꂽꍇ

			// Yړʂݒ肳ꂽꍇA
			if(my != 0.0){
				// Yړ
				moveY(my);
			} // end if Yړʂݒ肳ꂽꍇ

			// Xړʂݒ肳ꂽꍇA
			if(mx != 0.0){
				// Xړ
				moveX(mx);
			}

			// ړĂȂꍇA
			if(mx == 0){
				// ]
				super.setRotate(0);
			// Ɉړ̏ꍇA
			}else if(mx < 0){
				// ]
				super.setRotate(-15);
			// EɈړ̏ꍇA
			}else if(mx > 0){
				// ]
				super.setRotate(15);
			}

			// nʂɂȂ ܂ Xe[WȐꍇA
			if(!flgJimen || super.application.getStage() == 3){

				// Ԃ̏ꍇA
				if(time % 5 == 0){

					// ł銴o
					xx = Math.random() * 0.02 - 0.01;
					yy = Math.random() * 0.02 - 0.01;

					// Wݒ
					this.setTranslateX(x + xx);
					this.setTranslateY(y + yy);

				} // end if Ԃ̏ꍇ

			} // end if nʂɂȂ  Ԃ̏ꍇ

			// Xy[X ܂ Z ꂽꍇA
			if(application.isKeyPressed(KeyCode.SPACE) || application.isKeyPressed(KeyCode.Z)){

				// 
				if(timeTama % 30 == 0){

					// bNIĂGXvCg擾
					PRSpriteT spriteT = application.getPRLock().getLockOnSpriteT();

					// 𐶐
					PRSpriteTama spriteTama = new PRSpriteTama(application, this, spriteT);

					// eǉ
					application.addNode(spriteTama);

					// VbgX^[g
					application.startWaveShot();

					// C̐F̐ݒ
					materail.setDiffuseColor(Color.ORANGE);

				// 
				}else if(timeTama % 30 == 3){

					// C̐F̐ݒ
					materail.setDiffuseColor(Color.RED);

				}

				// ԁ{P
				timeTama++;

			// Xy[X  Z ĂȂꍇA
			}else{

				// eԂ
				timeTama = 0;

				// C̐F̐ݒ
				materail.setDiffuseColor(Color.RED);

			}

			//
			// 蔻
			//

			// E擾
			Bounds boundsThis = this.getBoundsInParent();

			// 蔻肪̂ŁAɂ߂ɂ
			// BoundśAprotectedŐłȂ̂ŁABoundingBoxŐ
			boundsThis = new BoundingBox(
				boundsThis.getMinX() + 0.15,
				boundsThis.getMinY() + 0.2,
				boundsThis.getMinZ(),
				boundsThis.getWidth() - 0.3,
				boundsThis.getHeight() -0.4,
				boundsThis.getDepth() + 0.4
			);

			// XvCgꗗ擾
			ObservableList<Node> nodeLst = application.getNodeLst();

			// XvCgꗗ̌擾
			int countNodeLst = nodeLst.size();

			// XvCgꗗ̌A[v
			for(int i = 0; i < countNodeLst; i++){

				// m[h擾
				Node node = nodeLst.get(i);

				// GXvCgȊȌꍇA
				if(!(node instanceof PRSpriteT)){
					// ReBj[
					continue;
				}

				// GXvCgɕϊ
				PRSpriteT spriteT = (PRSpriteT)node;

				// E擾
				Bounds boundsT = node.getBoundsInParent();

				// s擾
				double depth = boundsT.getDepth();

				// sȂXvCg̏ꍇA
				// QXvCg̏ꍇA
				if(depth == 0.0){
					// s𕝂Ƃ
					depth = boundsT.getWidth();
				}

				// 蔻肪̂ŁAɂ߂ɂ
				// BoundśAprotectedŐłȂ̂ŁABoundingBoxŐ
				Bounds boundsT2 = new BoundingBox(
					boundsT.getMinX() + boundsT.getWidth() * (0.5 - spriteT.getHaniX() / 2),
					boundsT.getMinY() + boundsT.getHeight() * (0.5 - spriteT.getHaniY() / 2),
					boundsT.getMinZ() + depth * (0.5 - spriteT.getHaniZ() / 2),
					boundsT.getWidth() * spriteT.getHaniX(),
					boundsT.getHeight() * spriteT.getHaniY(),
					depth * spriteT.getHaniZ()
				);

				// ĂꍇA
				if(boundsThis.intersects(boundsT2)){

					// G؂̏ꍇA
					if(spriteT instanceof PRSpriteShrub){
						// ReBj[
						continue;
					}

					// G[h̏ꍇA
					if(flgMuteki){
						// ReBj[
						continue;
					}

					// G̏ꍇA
					if(spriteT.isBomb()){
						// ReBj[
						continue;
					}

					// Փ
					bump();

				}

			} // end for XvCgꗗ̌A[v

		// tF[Y|Փ
		}else if(phase == PHASE_BUMP){

			// 0.25b
			if(time < 15){

				// Ȃ

			// 0.75b
			}else if(time < 45){

				// ړ
				this.moveY(-0.01);

				// 0.5b
				if(time == 30){

					// ]߂
					super.setRotate(0);

					// ]ݒ
					super.setRotationAxis(px);

					// ]
					super.setRotate(90);
					groupArmRight.setRotate(90);
					groupFire.setRotate(90);
					groupArmLeft.setRotate(90);
					groupLegRight.setRotate(90);
					groupLegLeft.setRotate(90);

				} // end if 0.5b

			// 1b
			}else if(time == 60){

				// ]ݒ
				super.setRotationAxis(px);

				// ]
				super.setRotate(180);

				groupArmRight.setRotate(180);
				groupFire.setRotate(180);
				groupArmLeft.setRotate(180);
				groupLegRight.setRotate(0);
				groupLegLeft.setRotate(0);

			// 1.5b
			}else if(time < 90){

				// ړ
				this.moveY(0.01);

			// 2.5b
			}else if(time < 150){

				// ړ
				this.moveY(0.02);

			}

		// tF[Y| Q[NA ̏ꍇA
		}else if(phase == PHASE_GAME_CLEAR){

			// ړ
			this.setTranslateZ(6.0 + time);

		} // end if tF[Y

		// tF[Y| G ܂ Q[łQbA
		if(phase == PHASE_MUTEKI || phase == PHASE_GAME && time <= 120){

			// _
			if(time % 25 < 10){
				this.setVisible(false);
			}else{
				this.setVisible(true);
			}

			// tF[Y| G  QDWbRb܂ŁA
			if(phase == PHASE_MUTEKI && 168 <= time && time <= 180){

				// ֈړ
				moveY(-0.1);

			// Q[łQbA
			}else if(phase == PHASE_GAME && time == 120){

				// \
				this.setVisible(true);

				// Gԉ
				flgMuteki = false;

			} // end if Q[łQb

		} // end if  tF[Y| G ܂ Q[łQb

		// tF[Y| G ܂ Q[ ̏ꍇA
		if(phase == PHASE_MUTEKI || phase == PHASE_GAME){

			// Xe[WRȊȌꍇA
			if(super.application.getStage() != 3){

				// nʂɂꍇA
				if(flgJimen){

					// pxvZ
					angleLeg = angleLeg + 8 * dirLeg;

					if(Math.abs(angleLeg) > 50){
						// 𔽓]
						dirLeg = -dirLeg;
					}

					groupArmRight.setRotate(angleLeg * 1.5);
					groupFire.setRotate(angleLeg * 1.5);
					groupArmLeft.setRotate(-angleLeg * 1.5);
					groupLegRight.setRotate(-angleLeg);
					groupLegLeft.setRotate(angleLeg);

				// nʂɂȂꍇA
				}else{

					groupArmRight.setRotate(180);
					groupFire.setRotate(180);
					groupArmLeft.setRotate(0);
					groupLegRight.setRotate(0);
					groupLegLeft.setRotate(0);

				} // end if nʂɂȂꍇ

			// Xe[WȐꍇA
			}else{

				groupArmRight.setRotate(180);
				groupFire.setRotate(180);
				groupArmLeft.setRotate(0);
				groupLegRight.setRotate(0);
				groupLegLeft.setRotate(0);

			} // end if Xe[W

		} // end if tF[Y| G ܂ Q[ ̏ꍇ

	} // end run

	/**
	 * Yړ
	 * <pre>
	 * ړƒn̊mFĂ܂B
	 * </pre>
	 * @param my Yړ
	 */
	public void moveY(double my){

		// ړ
		double y1 = y + my;

		// ̈ȌꍇA
		if(y1 < -4.0){

			// ߂
			y1 = -4.0;
			my = 0.0;

		// nʂ傤ǂ̏ꍇA
		}else if(y1 == yJimen){

			// nʂɂ
			flgJimen = true;

		// ̈ȌꍇA
		}else if(y1 > yJimen){

			// ړʂ␳
			my = yJimen - y;
			y1 = yJimen;

			// nʂɂ
			flgJimen = true;

		// LȊȌꍇA
		}else{

			// nʂɂȂ
			flgJimen = false;

		} // end if

		// Wݒ
		y = y1;
		this.setTranslateY(y);

		// Jړ
		application.moveCameraY(my / 1.5);

	} // end moveY

	/**
	 * Xړ
	 * @param mx Xړ
	 */
	public void moveX(double mx){

		// wiړ
		application.moveSkyX(-mx * 40);

		// ړ
		x = x + mx;

		// ̈ȌꍇA
		if(x < -1.5){
			// ߂
			x = -1.5;
		// ̈ȌꍇA
		}else if(x > 1.5){
			// ߂
			x = 1.5;
		}

		// Wݒ
		this.setTranslateX(x);

	} // end moveX

	/**
	 * GԎ擾
	 */
	public boolean isMuteki(){
		return flgMuteki;
	}

	/**
	 * ՓˏԎ擾
	 */
	public boolean isBump(){
		return flgBump;
	}

	/**
	 * X^[g
	 */
	public void start(){

		// tF[Y|X^[g
		phase = PHASE_START;

	} // end start

	/**
	 * vC[̈ʒu߂
	 */
	public void initPos(){

		// ʒu߂
		x = 0.0;
		this.setTranslateX(x);
		y = yJimen;
		this.setTranslateY(yJimen);
		this.setTranslateZ(6.0);

	} // end initPos

	/**
	 * Փ
	 */
	public void bump(){

		// Ԃ
		time = 0;

		// Փˏ
		flgBump = true;

		// tF[Y|Փ˂
		phase = PHASE_BUMP;

		// AvP[VɏՓ˂`
		application.bump();

	} // end clash

	/**
	 * Q[NA
	 */
	public void clearGame(){

		// Ԃ
		time = 0;

		// tF[Y|Q[NA
		phase = PHASE_GAME_CLEAR;

	} // end clearGame

	/**
	 * [hݒ
	 */
	public void setMode(int mode){

		// [hݒ
		if(mode == 0){
			moveUp = KeyCode.DOWN;
			moveDown = KeyCode.UP;
		}else{
			moveUp = KeyCode.UP;
			moveDown = KeyCode.DOWN;
		}

	} // end run

}
