import javafx.collections.ObservableList;
import javafx.geometry.BoundingBox;
import javafx.geometry.Bounds;
import javafx.scene.Node;
import javafx.scene.image.Image;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.MeshView;
import javafx.scene.shape.TriangleMesh;

/**
 * 
 */
public class PRSpriteTree extends PRSpriteT {

	private static float[]		POINTS		= {
		-0.5f, -1.0f, 0.0f,
		-0.5f,  1.0f, 0.0f,
		 0.5f,  1.0f, 0.0f,
		 0.5f, -1.0f, 0.0f
	};

	private static float[]		TEXCOORDS   = {
		0, 0,
		0, 1,
		1, 1,
		1, 0
	};

	private static int[]		FACES		= {
		0, 0, 1, 1, 2, 2,
		2, 2, 3, 3, 0, 0
	};

	/** C[W */
	private static Image		image		= null;

	/**
	 * 
	 */
	public static void init() {

		try{
			PRSpriteTree.image = PRImage.getImage("3d/image_f_tree2010.png");
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * RXgN^
	 * @param application PRApplication
	 * @param strPattern zup^[
	 * @param X␳ʒu
	 * @param pos ʒu
	 */
	public PRSpriteTree(PRApplication application, String strPattern, double xHosei, int pos){

		// X[p[NXĂяo
		super(application);

		try{

			// bVr[𐶐
			MeshView meshView = new MeshView();

			// bV𐶐
			TriangleMesh mesh = new TriangleMesh();

			mesh.getPoints().addAll(POINTS);
			mesh.getTexCoords().addAll(TEXCOORDS);
			mesh.getFaces().addAll(FACES);

			// }eA𐶐
			PhongMaterial material = new PhongMaterial();
			material.setDiffuseMap(image);

			// bVo^
			meshView.setMesh(mesh);
			meshView.setMaterial(material);

			double x = 0;

			// zup^[_
			if("_".equals(strPattern)){

				// _ɔzu
				x = Math.random() * 12.0 - 6.0;

			// zup^[ȄꍇA
			}else if("E".equals(strPattern)){

				// ʒu␳
				x = pos * 0.5 - 5 + xHosei;

			// zup^[^E獶̏ꍇA
			}else if("E獶".equals(strPattern)){

				// ʒu␳
				x = -pos * 0.5 + 5 + xHosei;

			// zup^[̏ꍇA
			}else if("".equals(strPattern)){

				// ʒu␳
				x = -5 + xHosei;

			// zup^[ȄꍇA
			}else if("E".equals(strPattern)){

				// ʒu␳
				x = 5 + xHosei;

			} // end if zup^[

			// Xݒ
			super.setTranslateX(x);

			// Zݒ
			super.setTranslateZ(100);

			// bVr[ǉ
			this.getChildren().add(meshView);

			// Yݒ
			Bounds bounds = this.getBoundsInParent();
			super.setTranslateY(-bounds.getHeight() / 2);

			// xݒ
			mz = -0.6;

			// eݒ
			application.addShadow(this, 0.6);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteTree

	/**
	 * s
	 */
	@Override
	public void run(){

		//
		// X
		//

		// ړʎ擾
		double mx = -application.getPRSpritePrusher().mx;

		// WvZ
		double x = super.getTranslateX();
		x = x + mx;

		// ړ
		super.setTranslateX(x);

		//
		// Z
		//

		// W擾
		double z = super.getTranslateZ();

		// WZ
		z = z + mz;

		// ʂ̊OɂłꍇA
		if(z < 0){
			// 폜
			super.remove();
		}

		// ړ
		super.setTranslateZ(z);

		//
		// 蔻
		//

		// ĂȂꍇA
		if(!flgBomb){

			// E擾
			Bounds boundsThis = this.getBoundsInParent();

			// 蔲鎞̂ŁAs
			// BoundśAprotectedŐłȂ̂ŁABoundingBoxŐ
			boundsThis = new BoundingBox(
				boundsThis.getMinX(),
				boundsThis.getMinY(),
				boundsThis.getMinZ(),
				boundsThis.getWidth(),
				boundsThis.getHeight(),
				boundsThis.getDepth() + 2.5
			);

			// XvCgꗗ擾
			ObservableList<Node> nodeLst = application.getNodeLst();

			// XvCgꗗ̌擾
			int countNodeLst = nodeLst.size();

			// XvCgꗗ̌A[v
			for(int i = 0; i < countNodeLst; i++){

				// XvCg擾
				Node node = nodeLst.get(i);

				// ȅꍇA
				if(node instanceof PRSpriteTama){

					// ĂꍇA
					if(boundsThis.intersects(node.getBoundsInParent())){

						// 
						flgBomb = true;

						// e폜
						application.removeNode(node);

						// 𐶐
						PRSpriteBomb spriteBomb = new PRSpriteBomb(application, this, 0.04);

						// AvP[Vɔǉ
						application.addNode(spriteBomb);

						// _ǉ
						application.addScore(100);

						// X^[g
						application.startWaveBomb();

						// [v𔲂
						break;

					} // end if Ăꍇ

				} // end if ȅꍇ

			} // end for XvCgꗗ̌A[v

		} // end if ĂȂꍇ

	} // end run

	/**
	 * 蔻͈X
	 */
	@Override
	public double getHaniX() {
		return 0.1;
	}

	@Override
	public double getHaniY() {
		return 0.8;
	}

}
