import java.util.ArrayList;

/**
 * 雲
 */
public class PRSpriteGroupCloud extends PRSpriteGroup implements PRConstant {

	/** 雲一覧 */
	private		ArrayList<PRSpriteCloud>	spriteCloudLst		= null;

	/**
	 * コンストラクタ
	 * @param application PRApplication
	 * @param strParam 配置パターン
	 */
	public PRSpriteGroupCloud(PRApplication application){

		super(application);

		// 雲一覧を生成
		spriteCloudLst = new ArrayList<PRSpriteCloud>();

	} // end PRSpriteGroupCloud

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * <pre>
	 */
	public void run(){

		// 時間まで、
		if(time < 100){

			// 時間が来たら、
			if(time % 2 == 0){

				// スプライトを生成
				PRSpriteCloud spriteCloud = new PRSpriteCloud(super.getPRApplication());

				// スプライトを追加
				super.getPRApplication().addNode(spriteCloud);

				// 雲一覧に追加
				spriteCloudLst.add(spriteCloud);

			} // end if 時間が来たら

		} // end if 時間まで

	} // end run

	/**
	 * 終了
	 * <pre>
	 * 当グループと全ての雲を終了させます。
	 * <pre>
	 */
	public void finish(){

		// 雲一覧の件数を取得
		int countSpriteCloudLst = spriteCloudLst.size();

		// 雲一覧の件数分、ループ
		for(int i = 0; i < countSpriteCloudLst; i++){

			// 雲を取得
			PRSpriteCloud spriteCloud = spriteCloudLst.get(i);

			// 雲を終了させる
			spriteCloud.finish();

		} // end for 雲一覧の件数分、ループ

		// スプライトグループを消す
		super.getPRApplication().removeSpriteGroup(this);

	} // end finish

}
