/**
 * 柱
 */
public class PRSpriteGroupPole extends PRSpriteGroup implements PRConstant {

	/** 配置パターン */
	private		String		strPattern	= null;

	/**
	 * コンストラクタ
	 * @param application PRApplication
	 * @param strParam 配置パターン
	 */
	public PRSpriteGroupPole(PRApplication application, String strParam){
		super(application);
		this.strPattern = strParam;
	}

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * <pre>
	 */
	public void run(){

		// 一定時間経過の場合、
		if((time % 15) == 0){

			// スプライトを生成
			PRSpritePole spritePole = new PRSpritePole(super.getPRApplication());

			// 配置パターン＝ランダム
			if("ランダム".equals(strPattern)){

				// 何もしない
				// ランダムに配置

			// 配置パターン＝左から右の場合、
			}else if("左から右".equals(strPattern)){

				// 位置を補正
				spritePole.setTranslateX(time / 15 * 0.5 - 5);

			} // end if 配置パターン

			// スプライトを追加
			super.getPRApplication().addNode(spritePole);

		} // end if 一定時間経過の場合

		// ５秒経ったら、
		if(time > 300){
			// スプライトグループを消す
			super.getPRApplication().removeSpriteGroup(this);
		}

	} // end run

}
