/**
 * レッド・アイ
 * <pre>
 * SKKから復活登場！
 * </pre>
 */
public class PRSpriteGroupRedEye extends PRSpriteGroup implements PRConstant {

	/** 配置パターン */
	private		String		strPattern	= null;

	/** 残機 */
	private		int			remaining		= 0;

	/**
	 * コンストラクタ
	 * @param application PRApplication
	 * @param strParam 配置パターン
	 */
	public PRSpriteGroupRedEye(PRApplication application, String strParam){

		super(application);

		// パターンを保持
		this.strPattern = strParam;

		// ストーリーを停止する
		super.getPRApplication().getPRStoryPrusher().stop();

		// 配置パターン＝ボスの場合、
		if("ボス".equals(strPattern)){

			// レッド・アイBGMスタート
			super.getPRApplication().startMP3BGMRedEye();

			// 行ループ
			for(int row = 0; row < 3; row++){

				// 列ループ
				for(int col = 0; col < 3; col++){

					// スプライトを生成
					PRSpriteRedEye spriteRedEye = new PRSpriteRedEye(super.getPRApplication(), this, this.strPattern);

					// 残機＋１
					remaining++;

					// X設定
					spriteRedEye.setTranslateX(row - 1.0);
					// Y設定
					spriteRedEye.setTranslateY(col - 4.0);

					// スプライトを追加
					super.getPRApplication().addNode(spriteRedEye);

				} // end for 列ループ

			} // end for 行ループ

		} // end if 配置パターン

	} // end PRSpriteGroupRedEye

	/**
	 * 実行
	 * <pre>
	 * 当オブジェクトのふるまいを決定します。
	 * <pre>
	 */
	public void run(){

		// 配置パターン＝ザコの場合、
		if("ザコ".equals(strPattern)){

			// 1秒
			if(time < 60){

				// 一定時間経過の場合、
				if((time % 12) == 0){

					// スプライトを生成
					PRSpriteRedEye spriteRedEye = new PRSpriteRedEye(super.getPRApplication(), this, this.strPattern);

					// 残機＋１
					remaining++;

					// X設定
					spriteRedEye.setTranslateX(time / 12 * 0.8 - 2.0);
					// Y設定
					spriteRedEye.setTranslateY(-4.0);

					// スプライトを追加
					super.getPRApplication().addNode(spriteRedEye);

				} // end if 一定時間経過の場合

			} // end if 1秒

		// 配置パターン＝ボスの場合、
		}else if("ボス".equals(strPattern)){

			// 残機が無くなった場合、
			if(remaining == 0){

				// 1秒
				if(time > 120){

					// ストーリーを再開する
					super.getPRApplication().getPRStoryPrusher().start();

					// ファンファーレBGMスタート
					super.getPRApplication().startMP3BGMFanfare();

					// スプライトグループを消す
					super.getPRApplication().removeSpriteGroup(this);

				} // end if 1秒

			} // end if 残機が無くなった場合

		} // end if 配置パターン

	} // end run

	/**
	 * スプライト削除
	 * <pre>
	 * スプライトグループで管理しているスプライトを削除します。
	 * <pre>
	 */
	public void removeSprite(){

		// 残機−１
		remaining--;

		// 残機が無くなった場合、
		if(remaining == 0){

			// 配置パターン＝ザコの場合、
			if("ザコ".equals(strPattern)){

				// ストーリーを再開する
				super.getPRApplication().getPRStoryPrusher().start();

				// スプライトグループを消す
				super.getPRApplication().removeSpriteGroup(this);

			// 配置パターン＝ボスの場合、
			}else if("ボス".equals(strPattern)){

				// 時間を戻す
				time = 0;

				// レッド・アイBGMストップ
				super.getPRApplication().stopMP3BGMRedEye();

			}

		}

	} // end removeSprite

}
