import javafx.geometry.Bounds;
import javafx.scene.Node;
import javafx.scene.paint.Color;
import javafx.scene.paint.PhongMaterial;
import javafx.scene.shape.Cylinder;

/**
 * 影
 */
public class PRSpriteShadow extends PRSprite {

	/** 親ノード */
	private			Node		node			= null;

	/**
	 * 初期化
	 */
	public static void init() {

		try{
		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end init

	/**
	 * コンストラクタ
	 * @param application PRApplication
	 * @param node 親ノード
	 */
	public PRSpriteShadow(PRApplication application, Node node){

		this(application, node, -1.0);

	} // end PRSpriteShadow

	/**
	 * コンストラクタ
	 * @param application PRApplication
	 * @param node 親ノード
	 * @param radius 半径
	 */
	public PRSpriteShadow(PRApplication application, Node node, double radius){

		// スーパークラスを呼び出す
		super(application);

		try{

			// 親ノードを保持
			this.node = node;

			// 大きさを取得
			Bounds bouds = node.getBoundsInParent();
			double width = bouds.getWidth();
			double depth = bouds.getDepth();

			// 座標設定
			super.setTranslateX(node.getTranslateX());
			super.setTranslateY(-0.001);
			super.setTranslateZ(node.getTranslateZ());

			// 半径が設定されていない場合、
			if(radius == -1){

				// 大きさの平均をとる
				radius = (width + depth) / 2;

			}

			// シリンダーを生成
			Cylinder cylinder = new Cylinder(radius, 0.0001, 12);

			// マテリアルを生成
			PhongMaterial material = new PhongMaterial();
			material.setDiffuseColor(Color.BLACK);

			// マテリアルを登録
			cylinder.setMaterial(material);

			// 影を自分のグループに追加
			this.getChildren().add(cylinder);

		}catch(Exception ex){
			ex.printStackTrace();
		}

	} // end PRSpriteShadow

	/**
	 * 実行
	 */
	@Override
	public void run(){

		// 座標取得
		double x = this.node.getTranslateX();
		double z = this.node.getTranslateZ();

		// 移動
		super.setTranslateX(x);
		super.setTranslateZ(z);

	} // end run

}
